
///////////////////////////////////////////////////////////////////////////////
//
//	level_camui.cpp
//

#include <stdio.h>
#include "id.h"
#include "project.h"

#ifdef _MSC_VER
#include <uxtheme.h>
#endif

LevelCamerasManager::LevelCamerasManager(LevelManager *_level, ProjectManager *_project)
: level(_level), project(_project), bDragging(DRAG_NONE)
{
	hpnCameraLine = NULL;
	hpnCameraSel  = NULL;
	hbrCameraRect = NULL;
	hbrCameraLine = NULL;
	hbrCameraSel  = NULL;
	hftCameraText = NULL;
}

LevelCamerasManager::~LevelCamerasManager(){
	if (hpnCameraLine) DeleteObject(hpnCameraLine);
	if (hpnCameraSel)  DeleteObject(hpnCameraSel);
	if (hbrCameraRect) DeleteObject(hbrCameraRect);
	if (hbrCameraLine) DeleteObject(hbrCameraLine);
	if (hbrCameraSel)  DeleteObject(hbrCameraSel);
	if (hftCameraText) DeleteObject(hftCameraText);
}

BOOL LevelCamerasManager::create(HWND hwTab){
	if (!create_dialog(hwTab)) return FALSE;
	return TRUE;
}

void LevelCamerasManager::set_state(bool bEnabled){
	EnableWindow(GetDlgItem(hWnd, IDC_LIST0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK2), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK3), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK4), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_CHECK5), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT2), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_EDIT4), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON5), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_BUTTON6), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC0), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC1), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC2), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC3), bEnabled);
	EnableWindow(GetDlgItem(hWnd, IDC_STATIC4), bEnabled);
	return;
}


BOOL LevelCamerasManager::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_INITDIALOG:
			{
#ifdef _MSC_VER
				HMODULE hMod;
				hMod = LoadLibrary("uxtheme.dll");
				if (hMod)
				{
					typedef HRESULT (WINAPI *EnableThemeDialogTexturePROC)(HWND, DWORD);
					EnableThemeDialogTexturePROC pEnableThemeDialogTexture;
					pEnableThemeDialogTexture = (EnableThemeDialogTexturePROC)GetProcAddress(hMod, "EnableThemeDialogTexture");
					if (pEnableThemeDialogTexture)
						pEnableThemeDialogTexture(hWnd, ETDT_ENABLETAB);
					FreeLibrary(hMod);
				}
#endif
				SetWindowLong(GetDlgItem(hDlg, IDC_EDIT0), GWL_EXSTYLE, 0);
				unable_edit_change = false;
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_LIST0:
					if (HIWORD(wParam) == LBN_SELCHANGE){
						int sel = SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0);
						sel_changed(sel);
						if (bShowCameras){
							isel = sel;
							level->excluse_pages(LEVEL_CAMERAS);
							level->redraw_default();
						}
						return TRUE;
					}
					if (HIWORD(wParam) == LBN_DBLCLK){
						jump(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
						return TRUE;
					}
					break;
				case IDC_CHECK0:
					SetDlgItemText(hWnd, IDC_CHECK0, "Eɑ(2)*");
					return TRUE;
				case IDC_CHECK1:
					SetDlgItemText(hWnd, IDC_CHECK1, "Eɑ*");
					return TRUE;
				case IDC_CHECK2:
					SetDlgItemText(hWnd, IDC_CHECK2, "ɑ(2)*");
					return TRUE;
				case IDC_CHECK3:
					SetDlgItemText(hWnd, IDC_CHECK3, "ɑ*");
					return TRUE;
				case IDC_CHECK4:
					SetDlgItemText(hWnd, IDC_CHECK4, "P1*");
					return TRUE;
				case IDC_CHECK5:
					SetDlgItemText(hWnd, IDC_CHECK5, "P2*");
					return TRUE;
				case IDC_EDIT1:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC1, "[(&L)*:");
						return TRUE;
					}
					break;
				case IDC_EDIT2:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC2, "[(&T)*:");
						return TRUE;
					}
					break;
				case IDC_EDIT3:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC3, "E[(&R)*:");
						return TRUE;
					}
					break;
				case IDC_EDIT4:
					if (HIWORD(wParam) == EN_CHANGE && !unable_edit_change){
						SetDlgItemText(hWnd, IDC_STATIC4, "[(&B)*:");
						return TRUE;
					}
					break;
				case IDC_BUTTON1:	// Kp
					cam_apply(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON4:	// 
					cam_up(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON5:	// 
					cam_down(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDC_BUTTON6:	// \[g
					cam_sort(SendDlgItemMessage(hDlg, IDC_LIST0, LB_GETCURSEL, 0, 0));
					return TRUE;
			}
			break;
			/*
		case WM_CTLCOLORDLG:
			//return (BOOL)GetStockObject(NULL_BRUSH);
		case WM_CTLCOLORBTN:
		case WM_CTLCOLOREDIT:
		case WM_CTLCOLORLISTBOX:
		case WM_CTLCOLORMSGBOX:
		case WM_CTLCOLORSCROLLBAR:
		case WM_CTLCOLORSTATIC:
			break;
			return (BOOL)GetStockObject(NULL_BRUSH);//*/
	}
	return FALSE;
}

void LevelCamerasManager::cam_apply(int sel){
	char s[256], s2[256];
	LevelCamerasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	CameraAllocData data_before = *i_sel;
	input_camera_data(&*i_sel);
	output_camera_data(&*i_sel, sel);
	// ROMf[^ɔf
	LADRS adrs_levels = get_camera_levels_adrs();
	SADRS adrs_cameras = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_cameras+sel*CameraAllocData::size, level->get_code());
	// Xgɔf
	get_camera_text(s2, sizeof s2, &*i_sel);
	sprintf_s(s, sizeof s, "#%d: %s", isel, s2);
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	level->redraw_default();
	// Undoobt@֒ǉ
	LevelCameraApply_UndoMethod *undo = new LevelCameraApply_UndoMethod(project, level, this,
		level_num, sel,	&data_before, &*i_sel);
	project->undo_buffer.add_method(undo);
	return;
}

void LevelCamerasManager::cam_up(int sel){
	char s[256], s2[256];
	if (sel <= 0) return;
	LevelCamerasData::iterator i_sel = get_iterator(sel), i_otr, i_end = data.end();
	if (i_sel == i_end) return;
	// Undoobt@֒ǉ
	LevelCameraUp_UndoMethod *undo = new LevelCameraUp_UndoMethod(project, level, this, level_num, sel);
	project->undo_buffer.add_method(undo);
	CameraAllocData camera_temp = *i_sel;
	i_otr = i_sel--;
	*i_otr = *i_sel;
	*i_sel = camera_temp;
	sel--;
	if (isel != -1) isel = sel;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	get_camera_text(s, sizeof s, &(*i_sel));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s2);
	get_camera_text(s, sizeof s, &(*i_otr));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel+1, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)(sel+1), (LPARAM)s2);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_camera_levels_adrs();
	SADRS adrs_cameras = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_cameras+sel*CameraAllocData::size, level->get_code());
	(*i_otr).store_data(project, adrs_levels.bank, adrs_cameras+(sel+1)*CameraAllocData::size, level->get_code());
	sprintf_s(s, sizeof s, "%d", sel);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	level->redraw_default();
	return;
}

void LevelCamerasManager::cam_down(int sel){
	char s[256], s2[256];
	if (sel < 0 || sel >= (int)(data.get_camera_count())-1) return;
	LevelCamerasData::iterator i_sel = get_iterator(sel), i_otr, i_end = data.end();
	if (i_sel == i_end) return;
	// Undoobt@֒ǉ
	LevelCameraDown_UndoMethod *undo = new LevelCameraDown_UndoMethod(project, level, this, level_num, sel);
	project->undo_buffer.add_method(undo);
	CameraAllocData camera_temp = *i_sel;
	i_otr = i_sel++;
	*i_otr = *i_sel;
	*i_sel = camera_temp;
	sel++;
	if (isel != -1) isel = sel;
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)sel, 0);
	get_camera_text(s, sizeof s, &(*i_sel));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)sel, (LPARAM)s2);
	SendMessage(hwList, LB_DELETESTRING, (WPARAM)(sel-1), 0);
	get_camera_text(s, sizeof s, &(*i_otr));
	sprintf_s(s2, sizeof s2, "#%d: %s", sel-1, s);
	SendMessage(hwList, LB_INSERTSTRING, (WPARAM)(sel-1), (LPARAM)s2);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_camera_levels_adrs();
	SADRS adrs_cameras = adrs_levels.adrs + project->read_word(adrs_levels.bank, adrs_levels.adrs + level_num*2);
	(*i_sel).store_data(project, adrs_levels.bank, adrs_cameras+sel*CameraAllocData::size, level->get_code());
	(*i_otr).store_data(project, adrs_levels.bank, adrs_cameras+(sel-1)*CameraAllocData::size, level->get_code());
	sprintf_s(s, sizeof s, "%d", sel);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	level->redraw_default();
	return;
}

void LevelCamerasManager::cam_sort(int sel){
	int n, m;
	char s[256], s2[256];
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	LevelCamerasData data_before(data);
	int sel_before = sel;
	CameraAllocData camera_temp;
	LevelCamerasData::iterator i1, i2, i_end = data.end();
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	for (i1=data.begin(), n=0; i1!=i_end; i1++, n++){
		for (i2=i1++, m=n+1; i1!=i_end; i1++, m++){
			if (((*i2).pdl == (*i1).pdl) ? ((*i2).pdt > (*i1).pdt) : ((*i2).pdl > (*i1).pdl)){
				camera_temp = *i2;
				*i2 = *i1;
				*i1 = camera_temp;
				if (n == sel){
					sel = m;
				}else if (m == sel){
					sel = n;
				}
			}
		}
		i1 = i2;
		SendMessage(hwList, LB_DELETESTRING, (WPARAM)n, 0);
		get_camera_text(s, sizeof s, &*i1);
		sprintf_s(s2, sizeof s2, "#%d: %s", n, s);
		SendMessage(hwList, LB_INSERTSTRING, (WPARAM)n, (LPARAM)s2);
	}
	if (isel != -1) isel = sel;
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	SendMessage(hwList, LB_SETCURSEL, (WPARAM)sel, 0);
	// ROMɔf
	LADRS adrs_levels = get_camera_levels_adrs();
	data.store_data(project, adrs_levels.bank, adrs_levels.adrs, level_num, level->get_code());
	level->redraw_default();
	if (sel != -1){
		sprintf_s(s, sizeof s, "%d", sel);
		SetDlgItemText(hWnd, IDC_EDIT0, s);
	}
	// Undoobt@֒ǉ
	LevelCameraSort_UndoMethod *undo = new LevelCameraSort_UndoMethod(project, level, this, level_num,
		sel_before, sel, data_before, data);
	project->undo_buffer.add_method(undo);
	return;
}

void LevelCamerasManager::focus_on_camera(int sel){
	if (bShowCameras){
		isel = sel;
		LevelCamerasData::iterator i_sel = get_iterator(sel), i_end = data.end();
		if (i_sel == i_end) return;
		if (!level->is_point_in_screen((*i_sel).pdl, (*i_sel).pdt))
			level->set_scroll_pos((*i_sel).pdl, (*i_sel).pdt);
	}
	level->redraw_default();
	return;
}

void LevelCamerasManager::jump(int sel){
	LevelCamerasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	level->set_scroll_pos((*i_sel).pdl, (*i_sel).pdt);
	return;
}

void LevelCamerasManager::sel_changed(int sel){
	LevelCamerasData::iterator i_sel = get_iterator(sel), i_end = data.end();
	if (i_sel == i_end) return;
	output_camera_data(&*i_sel, sel);
	return;
}

void LevelCamerasManager::input_camera_data(CameraAllocData *camera){
	char s[256];
	int ivalue;
	camera->fr2	= IsDlgButtonChecked(hWnd, IDC_CHECK0) == BST_CHECKED;
	camera->fr	= IsDlgButtonChecked(hWnd, IDC_CHECK1) == BST_CHECKED;
	camera->fd2	= IsDlgButtonChecked(hWnd, IDC_CHECK2) == BST_CHECKED;
	camera->fd	= IsDlgButtonChecked(hWnd, IDC_CHECK3) == BST_CHECKED;
	camera->p1	= IsDlgButtonChecked(hWnd, IDC_CHECK4) == BST_CHECKED;
	camera->p2	= IsDlgButtonChecked(hWnd, IDC_CHECK5) == BST_CHECKED;
	GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	camera->pdl = ivalue;
	GetDlgItemText(hWnd, IDC_EDIT2, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	camera->pdt = ivalue;
	GetDlgItemText(hWnd, IDC_EDIT3, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	camera->pdr = ivalue;
	GetDlgItemText(hWnd, IDC_EDIT4, s, sizeof s);
	if (sscanf_s(s, "%d", &ivalue) <= 0) ivalue = 0;
	camera->pdb = ivalue;
	camera->normalize(level->get_code());
	SetDlgItemText(hWnd, IDC_CHECK0, "Eɑ(2)");
	SetDlgItemText(hWnd, IDC_CHECK1, "Eɑ");
	SetDlgItemText(hWnd, IDC_CHECK2, "ɑ(2)");
	SetDlgItemText(hWnd, IDC_CHECK3, "ɑ");
	SetDlgItemText(hWnd, IDC_CHECK4, "P1");
	SetDlgItemText(hWnd, IDC_CHECK5, "P2");
	SetDlgItemText(hWnd, IDC_STATIC1, "[(&L)");
	SetDlgItemText(hWnd, IDC_STATIC2, "[(&T)");
	SetDlgItemText(hWnd, IDC_STATIC3, "E[(&R)");
	SetDlgItemText(hWnd, IDC_STATIC4, "[(&B)");
	return;
}

void LevelCamerasManager::output_camera_data(const CameraAllocData *camera, int iIndex){
	char s[256];
	sprintf_s(s, sizeof s, "%d", iIndex);
	unable_edit_change = true;
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	CheckDlgButton(hWnd, IDC_CHECK0, camera->fr2 ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(hWnd, IDC_CHECK1, camera->fr ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(hWnd, IDC_CHECK2, camera->fd2 ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(hWnd, IDC_CHECK3, camera->fd ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(hWnd, IDC_CHECK4, camera->p1 ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(hWnd, IDC_CHECK5, camera->p2 ? BST_CHECKED : BST_UNCHECKED);
	sprintf_s(s, sizeof s, "%d", camera->pdl);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	sprintf_s(s, sizeof s, "%d", camera->pdt);
	SetDlgItemText(hWnd, IDC_EDIT2, s);
	sprintf_s(s, sizeof s, "%d", camera->pdr);
	SetDlgItemText(hWnd, IDC_EDIT3, s);
	sprintf_s(s, sizeof s, "%d", camera->pdb);
	SetDlgItemText(hWnd, IDC_EDIT4, s);
	unable_edit_change = false;
	SetDlgItemText(hWnd, IDC_CHECK0, "Eɑ(2)");
	SetDlgItemText(hWnd, IDC_CHECK1, "Eɑ");
	SetDlgItemText(hWnd, IDC_CHECK2, "ɑ(2)");
	SetDlgItemText(hWnd, IDC_CHECK3, "ɑ");
	SetDlgItemText(hWnd, IDC_CHECK4, "P1");
	SetDlgItemText(hWnd, IDC_CHECK5, "P2");
	SetDlgItemText(hWnd, IDC_STATIC1, "[(&L)");
	SetDlgItemText(hWnd, IDC_STATIC2, "[(&T)");
	SetDlgItemText(hWnd, IDC_STATIC3, "E[(&R)");
	SetDlgItemText(hWnd, IDC_STATIC4, "[(&B)");
	return;
}

LevelCamerasData::iterator LevelCamerasManager::get_iterator(int iIndex){
	LevelCamerasData::iterator i, i_end = data.end();
	int n;
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		if (n == iIndex) return i;
	}
	return i_end;
}




BOOL LevelCamerasManager::create_sys(){
	hpnCameraLine = CreatePen(PS_SOLID, 1, RGB(255, 0, 255));
	hpnCameraSel  = CreatePen(PS_SOLID, 3, RGB(255, 128, 255));
	hbrCameraRect = CreateSolidBrush(RGB(0, 0, 0));
	hbrCameraLine = CreateSolidBrush(RGB(255, 0, 255));
	hbrCameraSel  = CreateSolidBrush(RGB(128, 0, 128));
	hftCameraText = CreateFont(12, 0, 0, 0, FW_REGULAR, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, "lr SVbN");
	bShowCameras = GetPrivateProfileInt("MapView", "ShowCameras", TRUE, ConfigFileName) != 0;
	set_menuitem_state();
	return TRUE;
}

void LevelCamerasManager::set_menuitem_state(){
	MENUITEMINFO mi;
	mi.cbSize	= sizeof mi;
	mi.fMask	= MIIM_STATE;
	mi.fState	= bShowCameras ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(GetMenu(project->get_hWnd()), IDM_VIEW_CAMERAS, FALSE, &mi);
	SendMessage(project->get_hwTool(), TB_CHECKBUTTON, (WPARAM)IDM_VIEW_CAMERAS, (LPARAM)(bShowCameras?TRUE:FALSE));
	return;
}

void LevelCamerasManager::save_data(){
	char s[16];
	sprintf_s(s, sizeof s, "%d", bShowCameras);
	WritePrivateProfileString("MapView", "ShowCameras", s, ConfigFileName);
	return;
}

void LevelCamerasManager::get_camera_text(char *dst, size_t size, const CameraAllocData *camera){
	sprintf_s(dst, size, "(%d, %d, %d, %d)", camera->pdl, camera->pdt, camera->pdr, camera->pdb);
	return;
}

void LevelCamerasManager::load(int _level_num){
	char s[128], s2[128];
	level_num = _level_num;
	LADRS adrs_levels = get_camera_levels_adrs();
	HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)FALSE, 0);
	clear();
	data.load_data(project, adrs_levels.bank, adrs_levels.adrs, level_num, level->get_code());
	LevelCamerasData::iterator i, i_end = data.end();
	int n;
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		get_camera_text(s, sizeof s, &(*i));
		sprintf_s(s2, sizeof s2, "#%d: %s", n, s);
		SendMessage(hwList, LB_INSERTSTRING, (WPARAM)n, (LPARAM)s2);
	}
	SendMessage(hwList, WM_SETREDRAW, (WPARAM)TRUE, 0);
	isel = -1;
	return;
}

void LevelCamerasManager::clear(){
	LPCSTR empty = "";
	data.clear();
	SendMessage(GetDlgItem(hWnd, IDC_LIST0), LB_RESETCONTENT, 0, 0);
	unable_edit_change = true;
	SetDlgItemText(hWnd, IDC_EDIT0, empty);
	CheckDlgButton(hWnd, IDC_CHECK0, FALSE);
	CheckDlgButton(hWnd, IDC_CHECK1, FALSE);
	CheckDlgButton(hWnd, IDC_CHECK2, FALSE);
	CheckDlgButton(hWnd, IDC_CHECK3, FALSE);
	CheckDlgButton(hWnd, IDC_CHECK4, FALSE);
	CheckDlgButton(hWnd, IDC_CHECK5, FALSE);
	SetDlgItemText(hWnd, IDC_EDIT1, empty);
	SetDlgItemText(hWnd, IDC_EDIT2, empty);
	SetDlgItemText(hWnd, IDC_EDIT3, empty);
	SetDlgItemText(hWnd, IDC_EDIT4, empty);
	unable_edit_change = false;
	return;
}


void LevelCamerasManager::release_sel(){
	isel = -1;
	return;
}

bool LevelCamerasManager::mouseover(int pdx, int pdy){
	if (!bShowCameras) return false;
	char s[256];
	int n;
	bool bHorz, bVert;
	bool bLeft, bRight, bTop, bBottom;
	LevelCamerasData::reverse_iterator i, i_end = data.rend();
	for (i=data.rbegin(), n=data.get_camera_count()-1; i!=i_end; i++, n--){
		bHorz = pdy >= (*i).pdt && pdy < (*i).pdb;
		bVert = pdx >= (*i).pdl && pdx < (*i).pdr;
		bLeft   = bHorz && pdx >= (*i).pdl && pdx < (*i).pdl+CAMERA_LINEWIDTH;
		bRight  = bHorz && pdx >= (*i).pdr-CAMERA_LINEWIDTH && pdx < (*i).pdr;
		bTop    = bVert && pdy >= (*i).pdt && pdy < (*i).pdt+CAMERA_LINEWIDTH;
		bBottom = bVert && pdy >= (*i).pdb-CAMERA_LINEWIDTH && pdy < (*i).pdb;
		if (bLeft){
			if (bTop){			// 
				SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
			}else if (bBottom){	// 
				SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			}else{				// 
				SetCursor(LoadCursor(NULL, IDC_SIZEWE));
			}
		}else if (bRight){
			if (bTop){			// E
				SetCursor(LoadCursor(NULL, IDC_SIZENESW));
			}else if (bBottom){	// E
				SetCursor(LoadCursor(NULL, IDC_SIZENWSE));
			}else{				// E
				SetCursor(LoadCursor(NULL, IDC_SIZEWE));
			}
		}else{
			if (bTop){			// 
				SetCursor(LoadCursor(NULL, IDC_SIZENS));
			}else if (bBottom){	// 
				SetCursor(LoadCursor(NULL, IDC_SIZENS));
			}else if (
				pdx >= (*i).pdl && pdx < (*i).pdl+CAMERA_WIDTH &&
				pdy >= (*i).pdt && pdy < (*i).pdt+CAMERA_HEIGHT
				)
			{					// sړ
				SetCursor(LoadCursor(NULL, IDC_SIZEALL));
			}else{
				continue;
			}
		}
		sprintf_s(s, sizeof s, "J#%d: (%d, %d, %d, %d)", n, (*i).pdl, (*i).pdt, (*i).pdr, (*i).pdb);
		SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT, (LPARAM)s);
		s[0] = '\0';
		if ((*i).fr2) strcat_s(s, sizeof s, "Eɑ(2) ");
		if ((*i).fr) strcat_s(s, sizeof s, "Eɑ ");
		if ((*i).fd2) strcat_s(s, sizeof s, "ɑ(2) ");
		if ((*i).fd) strcat_s(s, sizeof s, "ɑ ");
		if ((*i).p1) strcat_s(s, sizeof s, "P1 ");
		if ((*i).p2) strcat_s(s, sizeof s, "P2 ");
		SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT_EX, (LPARAM)s);
		return true;
	}
	return false;
}

bool LevelCamerasManager::accepts_click(int pdx, int pdy){
	if (!bShowCameras) return false;
	int n;
	bool bHorz, bVert;
	bool bLeft, bRight, bTop, bBottom;
	LevelCamerasData::reverse_iterator i, i_end = data.rend();
	for (i=data.rbegin(), n=data.get_camera_count()-1; i!=i_end; i++, n--){
		bHorz = pdy >= (*i).pdt && pdy < (*i).pdb;
		bVert = pdx >= (*i).pdl && pdx < (*i).pdr;
		bLeft   = bHorz && pdx >= (*i).pdl && pdx < (*i).pdl+CAMERA_LINEWIDTH;
		bRight  = bHorz && pdx >= (*i).pdr-CAMERA_LINEWIDTH && pdx < (*i).pdr;
		bTop    = bVert && pdy >= (*i).pdt && pdy < (*i).pdt+CAMERA_LINEWIDTH;
		bBottom = bVert && pdy >= (*i).pdb-CAMERA_LINEWIDTH && pdy < (*i).pdb;
		if (bLeft){
			if (bTop){			// 
				bDragging = DRAG_LEFT_TOP;
				dragging_x = pdx - (drag_temp_x = (*i).pdl);
				dragging_y = pdy - (drag_temp_y = (*i).pdt);
			}else if (bBottom){	// 
				bDragging = DRAG_LEFT_BOTTOM;
				dragging_x = pdx - (drag_temp_x = (*i).pdl);
				dragging_y = pdy - (drag_temp_y = (*i).pdb);
			}else{				// 
				bDragging = DRAG_LEFT;
				dragging_x = pdx - (drag_temp_x = (*i).pdl);
			}
		}else if (bRight){
			if (bTop){			// E
				bDragging = DRAG_RIGHT_TOP;
				dragging_x = pdx - (drag_temp_x = (*i).pdr);
				dragging_y = pdy - (drag_temp_y = (*i).pdt);
			}else if (bBottom){	// E
				bDragging = DRAG_RIGHT_BOTTOM;
				dragging_x = pdx - (drag_temp_x = (*i).pdr);
				dragging_y = pdy - (drag_temp_y = (*i).pdb);
			}else{				// E
				bDragging = DRAG_RIGHT;
				dragging_x = pdx - (drag_temp_x = (*i).pdr);
			}
		}else{
			if (bTop){			// 
				bDragging = DRAG_TOP;
				dragging_y = pdy - (drag_temp_y = (*i).pdt);
			}else if (bBottom){	// 
				bDragging = DRAG_BOTTOM;
				dragging_y = pdy - (drag_temp_y = (*i).pdb);
			}else if (
				pdx >= (*i).pdl && pdx < (*i).pdl+CAMERA_WIDTH &&
				pdy >= (*i).pdt && pdy < (*i).pdt+CAMERA_HEIGHT
				)
			{					// sړ
				bDragging = DRAG_MOVE;
				dragging_x = pdx - (drag_temp_x = (*i).pdl);
				dragging_y = pdy - (drag_temp_y = (*i).pdt);
				drag_const_width  = (*i).pdr - (*i).pdl;
				drag_const_height = (*i).pdb - (*i).pdt;
			}else{
				continue;
			}
		}
		isel = n;
		SendMessage(GetDlgItem(hWnd, IDC_LIST0), LB_SETCURSEL, (WPARAM)isel, 0);
		sel_changed(n);
		return true;
	}
	isel = -1;
	return false;
}

void LevelCamerasManager::release_click(bool bApply){
	LevelCamerasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	if (bApply) cam_apply(isel);
	bDragging = DRAG_NONE;
	return;
}

void LevelCamerasManager::dragging(int pdx, int pdy){
	char s[256];
	LevelCamerasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	drag_temp_x = (pdx - dragging_x + 4) & ~7;
	drag_temp_y = (pdy - dragging_y + 4) & ~7;
	switch (bDragging){
		case DRAG_MOVE:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT1, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT2, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_x + drag_const_width);
			SetDlgItemText(hWnd, IDC_EDIT3, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y + drag_const_height);
			SetDlgItemText(hWnd, IDC_EDIT4, s);
			sprintf_s(s, sizeof s, "J#%d: (%d, %d, %d, %d)  (%d, %d, %d, %d)",
				isel, (*i).pdl, (*i).pdt, (*i).pdr, (*i).pdb,
				drag_temp_x, drag_temp_y, drag_temp_x+drag_const_width, drag_temp_y+drag_const_height);
			break;
		case DRAG_LEFT:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT1, s);
			sprintf_s(s, sizeof s, "J#%d [: %d  %d", isel, (*i).pdl, drag_temp_x);
			break;
		case DRAG_RIGHT:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT3, s);
			sprintf_s(s, sizeof s, "J#%d E[: %d  %d", isel, (*i).pdr, drag_temp_x);
			break;
		case DRAG_TOP:
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT2, s);
			sprintf_s(s, sizeof s, "J#%d [: %d  %d", isel, (*i).pdt, drag_temp_y);
			break;
		case DRAG_BOTTOM:
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT4, s);
			sprintf_s(s, sizeof s, "J#%d [: %d  %d", isel, (*i).pdb, drag_temp_y);
			break;
		case DRAG_LEFT_TOP:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT1, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT2, s);
			sprintf_s(s, sizeof s, "J#%d : (%d, %d)  (%d, %d)", isel, (*i).pdl, (*i).pdt, drag_temp_x, drag_temp_y);
			break;
		case DRAG_LEFT_BOTTOM:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT1, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT4, s);
			sprintf_s(s, sizeof s, "J#%d : (%d, %d)  (%d, %d)", isel, (*i).pdl, (*i).pdb, drag_temp_x, drag_temp_y);
			break;
		case DRAG_RIGHT_TOP:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT3, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT2, s);
			sprintf_s(s, sizeof s, "J#%d E: (%d, %d)  (%d, %d)", isel, (*i).pdr, (*i).pdt, drag_temp_x, drag_temp_y);
			break;
		case DRAG_RIGHT_BOTTOM:
			sprintf_s(s, sizeof s, "%d", drag_temp_x);
			SetDlgItemText(hWnd, IDC_EDIT3, s);
			sprintf_s(s, sizeof s, "%d", drag_temp_y);
			SetDlgItemText(hWnd, IDC_EDIT4, s);
			sprintf_s(s, sizeof s, "J#%d E: (%d, %d)  (%d, %d)", isel, (*i).pdr, (*i).pdb, drag_temp_x, drag_temp_y);
			break;
	}
	SendMessage(project->get_hwStatus(), SB_SETTEXT, (WPARAM)STATUS_INDEX_POINTING_OBJECT, (LPARAM)s);
	return;
}


void LevelCamerasManager::draw(BitmapBuffer *buf, const RECT *rtRedraw){
	if (!bShowCameras) return;
	char s[64];
	int n;
	RECT rt;
	POINT points[3];
	LevelCamerasData::iterator i, i_end = data.end();
	buf->select_object(hftCameraText);
	SetBkMode(buf->get_HDC(), TRANSPARENT);
	for (i=data.begin(), n=0; i!=i_end; i++, n++){
		if (bDragging!=DRAG_NONE && n==isel) continue;
		rt.left	  = (*i).pdl - rtRedraw->left;
		rt.top	  = (*i).pdt - rtRedraw->top;
		rt.right  = (*i).pdr - rtRedraw->left;
		rt.bottom = (*i).pdb - rtRedraw->top;
		if (n == isel){
			buf->select_object(hpnCameraSel);
			buf->select_object(GetStockObject(NULL_BRUSH));
			buf->rectangle(rt.left+2, rt.top+2, rt.right-2, rt.bottom-2);
			buf->rectangle(rt.left+2, rt.top+2, rt.left+CAMERA_WIDTH-2, rt.top+CAMERA_HEIGHT-2);
		}
		buf->select_object(hpnCameraLine);
		buf->select_object(GetStockObject(NULL_BRUSH));
		buf->rectangle(rt.left, rt.top, rt.right, rt.bottom);
		buf->select_object(GetStockObject(NULL_PEN));
		buf->select_object(hbrCameraLine);
		if ((*i).fr){
			points[0].x = rt.right;
			points[0].y = (rt.top + rt.bottom)/2;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[1].x;
			points[2].y = points[0].y + 6;
			Polygon(buf->get_HDC(), points, 3);
		}
		if ((*i).fr2){
			points[0].x = rt.right;
			points[0].y = (rt.top + rt.bottom)/2 - 10;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[1].x;
			points[2].y = points[0].y + 6;
			Polygon(buf->get_HDC(), points, 3);
			points[0].x = rt.right;
			points[0].y = (rt.top + rt.bottom)/2 + 10;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[1].x;
			points[2].y = points[0].y + 6;
			Polygon(buf->get_HDC(), points, 3);
		}
		if ((*i).fd){
			points[0].x = (rt.left + rt.right)/2;
			points[0].y = rt.bottom;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[0].x + 6;
			points[2].y = points[1].y;
			Polygon(buf->get_HDC(), points, 3);
		}
		if ((*i).fd2){
			points[0].x = (rt.left + rt.right)/2 - 10;
			points[0].y = rt.bottom;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[0].x + 6;
			points[2].y = points[1].y;
			Polygon(buf->get_HDC(), points, 3);
			points[0].x = (rt.left + rt.right)/2 + 10;
			points[0].y = rt.bottom;
			points[1].x = points[0].x - 6;
			points[1].y = points[0].y - 6;
			points[2].x = points[0].x + 6;
			points[2].y = points[1].y;
			Polygon(buf->get_HDC(), points, 3);
		}
		buf->select_object(hpnCameraLine);
		buf->select_object(n==isel? hbrCameraSel : hbrCameraRect);
		buf->rectangle(rt.left, rt.top, rt.left + CAMERA_WIDTH, rt.top + CAMERA_HEIGHT);
		SetTextColor(buf->get_HDC(), n==isel? RGB(255, 255, 255) : RGB(255, 0, 255));
		sprintf_s(s, sizeof s, "#%d", n);
		TextOut(buf->get_HDC(), rt.left+3, rt.top+3, s, strlen(s));
	}
	return;
}

void LevelCamerasManager::draw_f(BitmapBuffer *buf, const RECT *rtRedraw){
	if (!bShowCameras) return;
	if (bDragging == DRAG_NONE) return;
	LevelCamerasData::iterator i = get_iterator(isel);
	if (i == data.end()) return;
	char s[64];
	RECT rt = { (*i).pdl, (*i).pdt, (*i).pdr, (*i).pdb };
	POINT points[3];
	buf->select_object(hftCameraText);
	SetBkMode(buf->get_HDC(), TRANSPARENT);
	SetTextColor(buf->get_HDC(), RGB(255, 0, 255));
	switch (bDragging){
		case DRAG_MOVE:
			rt.left   = drag_temp_x;
			rt.top    = drag_temp_y;
			rt.right  = drag_temp_x + drag_const_width;
			rt.bottom = drag_temp_y + drag_const_height;
			break;
		case DRAG_LEFT:
			rt.left   = drag_temp_x;
			break;
		case DRAG_RIGHT:
			rt.right  = drag_temp_x;
			break;
		case DRAG_TOP:
			rt.top    = drag_temp_y;
			break;
		case DRAG_BOTTOM:
			rt.bottom = drag_temp_y;
			break;
		case DRAG_LEFT_TOP:
			rt.left   = drag_temp_x;
			rt.top    = drag_temp_y;
			break;
		case DRAG_LEFT_BOTTOM:
			rt.left   = drag_temp_x;
			rt.bottom = drag_temp_y;
			break;
		case DRAG_RIGHT_TOP:
			rt.right  = drag_temp_x;
			rt.top    = drag_temp_y;
			break;
		case DRAG_RIGHT_BOTTOM:
			rt.right  = drag_temp_x;
			rt.bottom = drag_temp_y;
			break;
	}
	rt.left   -= rtRedraw->left;
	rt.top    -= rtRedraw->top;
	rt.right  -= rtRedraw->left;
	rt.bottom -= rtRedraw->top;

	buf->select_object(hpnCameraSel);
	buf->select_object(GetStockObject(NULL_BRUSH));
	buf->rectangle(rt.left+2, rt.top+2, rt.right-2, rt.bottom-2);
	buf->rectangle(rt.left+2, rt.top+2, rt.left+CAMERA_WIDTH-2, rt.top+CAMERA_HEIGHT-2);

	buf->select_object(hpnCameraLine);
	buf->select_object(GetStockObject(NULL_BRUSH));
	buf->rectangle(rt.left, rt.top, rt.right, rt.bottom);
	buf->select_object(GetStockObject(NULL_PEN));
	buf->select_object(hbrCameraLine);
	if ((*i).fr){
		points[0].x = rt.right;
		points[0].y = (rt.top + rt.bottom)/2;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[1].x;
		points[2].y = points[0].y + 6;
		Polygon(buf->get_HDC(), points, 3);
	}
	if ((*i).fr2){
		points[0].x = rt.right;
		points[0].y = (rt.top + rt.bottom)/2 - 10;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[1].x;
		points[2].y = points[0].y + 6;
		Polygon(buf->get_HDC(), points, 3);
		points[0].x = rt.right;
		points[0].y = (rt.top + rt.bottom)/2 + 10;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[1].x;
		points[2].y = points[0].y + 6;
		Polygon(buf->get_HDC(), points, 3);
	}
	if ((*i).fd){
		points[0].x = (rt.left + rt.right)/2;
		points[0].y = rt.bottom;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[0].x + 6;
		points[2].y = points[1].y;
		Polygon(buf->get_HDC(), points, 3);
	}
	if ((*i).fd2){
		points[0].x = (rt.left + rt.right)/2 - 10;
		points[0].y = rt.bottom;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[0].x + 6;
		points[2].y = points[1].y;
		Polygon(buf->get_HDC(), points, 3);
		points[0].x = (rt.left + rt.right)/2 + 10;
		points[0].y = rt.bottom;
		points[1].x = points[0].x - 6;
		points[1].y = points[0].y - 6;
		points[2].x = points[0].x + 6;
		points[2].y = points[1].y;
		Polygon(buf->get_HDC(), points, 3);
	}
	buf->select_object(hpnCameraLine);
	buf->select_object(hbrCameraSel);
	buf->rectangle(rt.left, rt.top, rt.left + CAMERA_WIDTH, rt.top + CAMERA_HEIGHT);
	SetTextColor(buf->get_HDC(), RGB(255, 255, 255));
	sprintf_s(s, sizeof s, "#%d", isel);
	TextOut(buf->get_HDC(), rt.left+3, rt.top+3, s, strlen(s));
	//buf->rectangle(rt.left-2, rt.top-2, rt.right+2, rt.bottom+2);
	//buf->rectangle(rt.left-2, rt.top-2, rt.left+CAMERA_WIDTH+2, rt.top+CAMERA_HEIGHT+2);
	return;
}



BOOL LevelCamerasManager::command(WPARAM wParam, LPARAM lParam){
	if (LOWORD(wParam) == IDM_VIEW_CAMERAS){
		bShowCameras = !bShowCameras;
		set_menuitem_state();
		if (!bShowCameras){
			isel = -1;
		}
		level->redraw_default();
		return TRUE;

	}
	return FALSE;
}

BOOL LevelCamerasManager::translate_dialog_message(MSG *msg){
	return IsDialogMessage(hWnd, msg);
}






